/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 03/11/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;

import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import javax.persistence.*;
import javax.validation.constraints.*;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import lombok.Setter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.vo.MapObjekModulToModulAplikasiId;


@Entity
@Table(name = "MapObjekModulToModulAplikasi_S",indexes = {@Index(name = "MapObjekModulToModulAplikasi_S_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class MapObjekModulToModulAplikasi {
    
    @EmbeddedId
    private MapObjekModulToModulAplikasiId id ;
    
    private static final String cDefisEncrypted =INTEGER;
    @Column(name = "isEncrypted", columnDefinition = cDefisEncrypted)
    private Integer isEncrypted;
    
    private static final String cDefNoUrutObjek =INTEGER;
    @Column(name = "NoUrutObjek", columnDefinition = cDefNoUrutObjek)
    private Integer noUrutObjek;
    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "mapobjekmodultomodulaplikasi.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "mapobjekmodultomodulaplikasi.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "mapobjekmodultomodulaplikasi.version.notnull")
    private Integer version;
    

    
  
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdObjekModulAplikasi", referencedColumnName="KdObjekModulAplikasi",insertable=false, updatable=false),
    })
    // @ForeignKey(name="none")
     private ObjekModulAplikasi objekModulAplikasi;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdModulAplikasi", referencedColumnName="KdModulAplikasi",insertable=false, updatable=false),
    })
    // @ForeignKey(name="none")
     private ModulAplikasi modulAplikasi;
}
